PRINT N'Altering [dbo].[AccountSubAccountVCCBulkCloseBatchDetail]...';


GO
ALTER PROCEDURE [dbo].[AccountSubAccountVCCBulkCloseBatchDetail]
AS
BEGIN
	-- INSERT INTO [dbo].[TMP_TABLE_CLOSE] ([PlatformHash], [InstallationId], [AccountId], [SubAccountId], [VCC], [BatchTypeName], [BatchTypeId], [SystemService], [ProcessId], [EntityId], [ResultCode], [ResultDescription])
	-- SELECT [PlatformHash], [InstallationId], [AccountId], [SubAccountId], [VCC], [BatchTypeName], [BatchTypeId], [SystemService], [ProcessId], [EntityId], [ResultCode], [ResultDescription] FROM #AccountSubAccountVCCBulkCloseBatchDetailTemp;
	-- SELECT * FROM [dbo].[TMP_TABLE_CLOSE] 
	-- TRUNCATE TABLE [dbo].[TMP_TABLE_CLOSE] 

	-- ESTE PROCEDURE TIENE LA FUNCION DE ACTUALIZAR  A ISFINISHED = 1 UN BLOQUE DE DATA EXISTENTE EN LA TABLA DETALLE DE TRANSACCION
	-- A PARTIR DE UNA TABLA TEMPORAL
	
	-- HACEMOS EL UPDATE MARCAR COMO FINALIZADO UN BLOQUE DE REGISTROS DE LA TABLA TRANSACTION DETAILED 
	UPDATE ASAVDT
	SET ASAVDT.[IsFinished] = 1
		,ASAVDT.[IsValid] = ASAVDTTMP.[ResultCode]
		,ASAVDT.[Description] = ASAVDTTMP.[ResultDescription]
		,ASAVDT.[TimeStamp] = GETUTCDATE()
		,ASAVDT.[LastModifiedDate] = GETUTCDATE()
	FROM [dbo].[AccountSubAccountVCCDetailedTransaction] ASAVDT 
	INNER JOIN #AccountSubAccountVCCBulkCloseBatchDetailTemp ASAVDTTMP
	--INNER JOIN [dbo].[TMP_TABLE_CLOSE] ASAVDTTMP 
		ON ASAVDTTMP.[InstallationId] = ASAVDT.[InstallationId]
			AND ASAVDTTMP.[VCC] = ASAVDT.[VCC]
			AND ASAVDTTMP.[BatchTypeName] = ASAVDT.[BatchTypeName]
			AND ASAVDTTMP.[BatchTypeId] = ASAVDT.[BatchTypeId]
			AND ASAVDTTMP.[SystemService] = ASAVDT.[SystemService]
			AND ASAVDTTMP.[EntityId] = ASAVDT.[EntityId]
	WHERE ASAVDTTMP.[InstallationId] IS NOT NULL
		AND (ASAVDT.[IsFinished] = 0 OR ASAVDT.[IsFinished] IS NULL)

	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS BATCH RELACIONADOS EN EL CIERRE
	DECLARE MY_CURSOR CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY
		FOR 
		-- CONSULTAMOS LOS BATCH RELACIONADO A LA ACTUALIZACION DE LOS DETALLES MARCADOS COMO FINALIZADOS
		SELECT DISTINCT ASAVDT.[BatchId],
						ASAVDT.[SystemService]
			FROM [dbo].[AccountSubAccountVCCDetailedTransaction] ASAVDT 
			INNER JOIN #AccountSubAccountVCCBulkCloseBatchDetailTemp ASAVDTTMP 
			--INNER JOIN [dbo].[TMP_TABLE_CLOSE] ASAVDTTMP 
				ON ASAVDTTMP.[InstallationId] = ASAVDT.[InstallationId]
					AND ASAVDTTMP.[VCC] = ASAVDT.[VCC]
					AND ASAVDTTMP.[BatchTypeName] = ASAVDT.[BatchTypeName]
					AND ASAVDTTMP.[BatchTypeId] = ASAVDT.[BatchTypeId]
					AND ASAVDTTMP.[SystemService] = ASAVDT.[SystemService]
					AND ASAVDTTMP.[EntityId] = ASAVDT.[EntityId]
			WHERE ASAVDTTMP.[InstallationId] IS NOT NULL
				AND ASAVDT.[IsFinished] = 1

	-- DECLARARAMOS UNA VARIABLE PARA INDICAR EL BACTH ACTUAL QUE ESTAMOS RECORRIENDO
	DECLARE @CURRENT_BATCH_TO_UPDATE VARCHAR(50) = ''
	DECLARE @CURRENT_SYSTEM_SERVICE VARCHAR(50) = ''

	-- DECLARAMOS VARIABLES PARA ALMACENAR LOS DATOS RESUMEN
	DECLARE @CET_TOTAL_REQUEST INT = 0
	DECLARE @CET_TOTA_VALID_AUDIO INT = 0
	DECLARE @CET_TOTAL_VALID_ASYNC_DETAIL INT = 0
	DECLARE @CET_TOTAL_INVALID_AUDIO INT = 0
	DECLARE @CET_TOTAL_INVALID_ASYNC_DETAIL INT = 0
	DECLARE @CET_VALID_DURATION_TIME INT = 0
	DECLARE @CET_ROUNDED_DURATION_TIME INT = 0
	DECLARE @CET_VALID_TOTAL_QUERIES INT = 0
	DECLARE @CET_INVALID_TOTAL_QUERIES INT = 0
	DECLARE @CET_VALID_TOTAL_MODELS INT = 0
	DECLARE @CET_INVALID_TOTAL_MODELS INT = 0
	DECLARE @CET_TOTAL_CALL_PHRASES INT = 0
	DECLARE @CET_TOTAL_TEXT_PHRASES INT = 0
	DECLARE @CET_TOTAL_RAW_CHAR INT = 0
	DECLARE @CET_TOTAL_VALID_CHAR INT = 0

	
	-- ABRIMOS Y RECORREMOS EL ARRAY DE CAMPOS A ACTUALIZAR
	OPEN MY_CURSOR
	FETCH NEXT FROM MY_CURSOR INTO @CURRENT_BATCH_TO_UPDATE, @CURRENT_SYSTEM_SERVICE
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		WITH 
		-- DECLARAMOS UNA CTE PARA DEPOSITAR LOS RESULTADOS DEL RESUMEN PARA LA ACTUALIZACION
		CteTransactionDetailSummary AS (
			SELECT ASAVDT.[BatchID],
					ASAVDT.[SystemService],
					SUM(CASE WHEN ASAVDT.[IsValid] = 1 AND ASAVDT.[Channel] = 'CALL' AND ASAVDT.[Description] = 'SUCCED' THEN ASAVDT.[ValidDurationTime] ELSE 0 END) 'ValidDurationTime',
					SUM(CASE WHEN ASAVDT.[IsValid] = 1 AND ASAVDT.[Channel] = 'CALL' AND ASAVDT.[Description] = 'SUCCED' THEN CEILING(ASAVDT.[ValidDurationTime] * 1.00 / 60) * 60 ELSE 0 END) 'RoundedDurationTime',
					SUM(ASAVDT.[TotalRequest]) 'TotalRequest',
					SUM(CASE WHEN ASAVDT.[IsValid] = 1 AND ASAVDT.[Channel] = 'CALL' AND ASAVDT.[Description] = 'SUCCED' THEN 1 ELSE 0 END) 'ValidAudio',
					SUM(CASE WHEN ASAVDT.[IsValid] = 0 AND ASAVDT.[Channel] = 'CALL' AND ASAVDT.[Description] <> 'SUCCED'  THEN 1 ELSE 0 END) 'InvalidAudio',
					SUM(CASE WHEN ASAVDT.[IsValid] = 1 AND ASAVDT.[Channel] <> 'CALL' AND ASAVDT.[Description] = 'SUCCED' THEN 1 ELSE 0 END) 'ValidAsyncDetail',
					SUM(CASE WHEN ASAVDT.[IsValid] = 0 AND ASAVDT.[Channel] <> 'CALL' AND ASAVDT.[Description] <> 'SUCCED'  THEN 1 ELSE 0 END) 'InvalidAsyncDetail',
					SUM(CASE WHEN ASAVDT.[IsValid] = 1 AND ASAVDT.[Channel] = 'CALL' AND ASAVDT.[Description] = 'SUCCED' THEN ASAVDT.[TotalPhrases] ELSE 0 END) 'TotalCallPhrases',
					SUM(CASE WHEN ASAVDT.[IsValid] = 1 AND ASAVDT.[Channel] <> 'CALL' AND ASAVDT.[Description] = 'SUCCED' THEN ASAVDT.[TotalPhrases] ELSE 0 END) 'TotalTextPhrases',
					SUM(CASE WHEN ASAVDT.[IsValid] = 1 AND ASAVDT.[Channel] = 'CALL' AND ASAVDT.[Description] = 'SUCCED' THEN ASAVDT.[RawChar] ELSE 0 END) 'TotalRawChar', -- RAWCHAR ES EL TOTAL CARACTERES DEL JSON DESCARGADO DEL REPOSITORIO PARA LAS INTERACCIONES TEXT
					SUM(CASE WHEN ASAVDT.[IsValid] = 1 AND ASAVDT.[Channel] = 'CALL' AND ASAVDT.[Description] = 'SUCCED' THEN ASAVDT.[ValidChar] ELSE 0 END) 'TotalValidChar', -- VALID ES EL TOTAL CARACTERES DEL JSON PROCESADO POR IDATHA PARA TODAS LAS INTERACCIONES
					SUM(CASE WHEN ASAVDT.[IsValid] = 1 AND ASAVDT.[Description] = 'SUCCED' THEN 1 ELSE 0 END) 'ValidTotalQueries',
					SUM(CASE WHEN ASAVDT.[IsValid] = 0 AND ASAVDT.[Description] <> 'SUCCED'  THEN 1 ELSE 0 END) 'InvalidTotalQueries'
				FROM [dbo].[AccountSubAccountVCCDetailedTransaction] ASAVDT (NOLOCK) 
				WHERE ASAVDT.[BatchID] = @CURRENT_BATCH_TO_UPDATE
					AND ASAVDT.[SystemService] = @CURRENT_SYSTEM_SERVICE
				GROUP BY ASAVDT.[BatchID], ASAVDT.[SystemService]
		)
		
		--SELECT * FROM CteTransactionDetailSummary
		-- CAPTURAMOS LOS RESULTADOS DE LA CET PARA USARLOS MAS DE UNA VEZ
		SELECT @CET_TOTAL_REQUEST = ASAVDT.[TotalRequest],
				@CET_TOTA_VALID_AUDIO = ASAVDT.[ValidAudio],
				@CET_TOTAL_VALID_ASYNC_DETAIL = ASAVDT.[ValidAsyncDetail],
				@CET_TOTAL_INVALID_AUDIO = ASAVDT.[InvalidAudio],
				@CET_TOTAL_INVALID_ASYNC_DETAIL = ASAVDT.[InvalidAsyncDetail],
				@CET_VALID_DURATION_TIME = ASAVDT.[ValidDurationTime],
				@CET_ROUNDED_DURATION_TIME = ASAVDT.[RoundedDurationTime],
				@CET_VALID_TOTAL_QUERIES = ASAVDT.[ValidTotalQueries],
				@CET_TOTAL_CALL_PHRASES = ASAVDT.[TotalCallPhrases],
				@CET_TOTAL_TEXT_PHRASES = ASAVDT.[TotalTextPhrases],
				@CET_TOTAL_RAW_CHAR = ASAVDT.[TotalRawChar],
				@CET_TOTAL_VALID_CHAR = ASAVDT.[TotalValidChar]
			FROM CteTransactionDetailSummary ASAVDT (NOLOCK)
			WHERE ASAVDT.[BatchID] = @CURRENT_BATCH_TO_UPDATE
				AND ASAVDT.[SystemService] = @CURRENT_SYSTEM_SERVICE
		
		-- POR CADA SERVICIO DEL SISTEMA FINALIZADO, SE DEBA ACTUALIZAR EL CAMPO CORRESPONDIENTE EN LA SUMMARY
		UPDATE ASAVST
			SET ASAVST.[ValidDurationTime] = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION' THEN @CET_VALID_DURATION_TIME ELSE ASAVST.[ValidDurationTime] END 
				,ASAVST.[RoundedDurationTime] = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION' THEN @CET_ROUNDED_DURATION_TIME ELSE ASAVST.[RoundedDurationTime] END 
				,ASAVST.[TotalQueryRequest] = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'SEMANTIC_ANALYSIS' THEN @CET_TOTAL_REQUEST ELSE ASAVST.[TotalQueryRequest] END 
				,ASAVST.[ValidTotalQueries] = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'SEMANTIC_ANALYSIS' THEN @CET_VALID_TOTAL_QUERIES ELSE ASAVST.[ValidTotalQueries] END 
				,ASAVST.[TotalModelRequest] = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'COGNITIVE_ANALYSIS' THEN @CET_TOTAL_REQUEST ELSE ASAVST.[TotalModelRequest] END
				,ASAVST.[ValidTotalAudio] = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION' THEN @CET_TOTA_VALID_AUDIO ELSE ASAVST.[ValidTotalAudio] END 
				,ASAVST.[ValidTotalAsyncDetail] = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION' THEN @CET_TOTAL_VALID_ASYNC_DETAIL ELSE ASAVST.[ValidTotalAsyncDetail] END 
				,ASAVST.[InvalidTotalAudio] = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION' THEN @CET_TOTAL_INVALID_AUDIO ELSE ASAVST.[InvalidTotalAudio] END 
				,ASAVST.[InvalidTotalAsyncDetail] = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION' THEN @CET_TOTAL_INVALID_ASYNC_DETAIL ELSE ASAVST.[InvalidTotalAsyncDetail] END 
				,ASAVST.[TotalCallPhrases] = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION' THEN @CET_TOTAL_CALL_PHRASES ELSE ASAVST.[TotalCallPhrases] END 
				,ASAVST.[TotalTextPhrases] = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION' THEN @CET_TOTAL_TEXT_PHRASES ELSE ASAVST.[TotalTextPhrases] END 
				,ASAVST.[RawChar]  = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION' THEN @CET_TOTAL_RAW_CHAR ELSE ASAVST.[RawChar] END 
				,ASAVST.[ValidChar]  = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION' THEN @CET_TOTAL_VALID_CHAR ELSE ASAVST.[ValidChar] END 
				,ASAVST.[IsFinished] = 1 -- <- VALIDAR UNA FORMA DE ELIMINAR ESTA LINEA YA QUE DE ESTE DATO SE ENCARGA EL CLOSEBATCH
				,ASAVST.[LasModifiedDate] = GETUTCDATE()
				,ASAVST.[TimeStamp] = GETUTCDATE()
			FROM [dbo].[AccountSubAccountVCCSummaryTransaction] ASAVST (NOLOCK)
			/*INNER JOIN CteTransactionDetailSummary ASAVDT (NOLOCK)
				ON ASAVDT.[BatchID] = ASAVST.[BatchID]
					AND ASAVDT.[SystemService] = ASAVST.[SystemService]*/
			WHERE ASAVST.[BatchID] = @CURRENT_BATCH_TO_UPDATE
				AND ASAVST.[SystemService] = @CURRENT_SYSTEM_SERVICE
				--AND ASAVST.[IsFinished] = 0 
	
		IF @@ROWCOUNT = 0 
			RAISERROR('DATABABASE_ERROR_SYSTEM_SERVICE_SUMMARY_UPDATE_FAILED', 16, 16)

		-- EN CASO NUESTRO SYSTEM_SERVICE SEA TRANSCRIPCION, ACTUALIZAMOS EL VALIDDURATIONTIME, TOTALVALIDAUDIO Y TOTALINVALIDAUDIO DE LOS OTROS SYSTEMSERVICE(SEMANTIC Y COGNITIVE)
		IF @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION'
		BEGIN
			UPDATE ASAVST
				SET ASAVST.[ValidDurationTime] = @CET_VALID_DURATION_TIME 
					,ASAVST.[ValidTotalAudio] = @CET_TOTA_VALID_AUDIO
					--,ASAVST.[InvalidTotalAudio] = @CET_TOTAL_INVALID_AUDIO
					,ASAVST.[ValidTotalAsyncDetail] = @CET_TOTAL_VALID_ASYNC_DETAIL
					,ASAVST.[EndDate] = GETUTCDATE()
					,ASAVST.[LasModifiedDate] = GETUTCDATE()
					,ASAVST.[TimeStamp] = GETUTCDATE()
				FROM [dbo].[AccountSubAccountVCCSummaryTransaction] ASAVST (NOLOCK)
				WHERE ASAVST.[BatchID] = @CURRENT_BATCH_TO_UPDATE
					AND ASAVST.[SystemService] IN ('SEMANTIC_ANALYSIS', 'COGNITIVE_ANALYSIS')
		END
		
		FETCH NEXT FROM MY_CURSOR INTO @CURRENT_BATCH_TO_UPDATE, @CURRENT_SYSTEM_SERVICE
	END
	CLOSE MY_CURSOR
	DEALLOCATE MY_CURSOR

	-- TERMINADO EL PROCESO ELIMINAMOS LA TABLA TEMPORAL
	DROP TABLE #AccountSubAccountVCCBulkCloseBatchDetailTemp
END
GO
PRINT N'Altering [dbo].[GetCognitiveAnalysisAverageRequestPerMinute]...';


GO
ALTER PROCEDURE [dbo].[GetCognitiveAnalysisAverageRequestPerMinute](
	@InstallationId VARCHAR(50) = NULL,
	@VCC VARCHAR(50) = NULL
)
AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE RETORNAR UN NUMERO PROMEDIO DE REQUEST DE ANALISIS COGNITIVO EN UN MINUTO
	-- USADO POR [dbo].[AccountSubAccountVCCBatchSummaryCreate] Y [dbo].[GetAccountVccRates]
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY
		-- DECLARAMOS UNA VARIABLE PARA ALMACENAR EL VALOR DE SEGUNDOS POR REQUEST
		DECLARE @SECONDS_PER_REQUEST DECIMAL(5,2) = 0

		-- DECLARAMOS UNA VARIABLE PARA ALMACENAR EL VALOR DE REQUEST POR MINUTO
		DECLARE @REQUEST_PER_MINUTE DECIMAL(5,2) = 0
		
		-- *TASA DE SEGURO DE FACTURACION(DECIMAL): SI SE CAMBIA ESTE VALOR, SE DEBERA CAMBIAR TAMBIEN EN EL SP [dbo].[AccountSubAccountVCCBatchSummaryCreate]
		DECLARE @COGNITIVE_ANALYSIS_BILLING_SECURE_RATE DECIMAL(5, 2) = 0.15 -- <-SE BORRARA

		-- DECLARAMOS LAS VARIABLES PARA LOS RESULTADOS TOTALES
		DECLARE @TOTAL_AUDIOS DECIMAL(18, 5) = 0
		DECLARE @TOTAL_DURATION_TIME DECIMAL(18, 5) = 0
		DECLARE @TOTAL_VALID_DURATION_TIME DECIMAL(18, 5) = 0
		DECLARE @TOTAL_ROUNDED_DURATION_TIME DECIMAL(18, 5) = 0
		DECLARE @TOTAL_VALID_REQUEST DECIMAL(18, 5) = 0
					
		-- RECUPERAMOS LOS VALORES TOTALES DE LOS ULTIMOS SIETE DIAS
		SELECT TOP 100 @TOTAL_AUDIOS = SUM(ASAVST.[TotalAudio]), 
				@TOTAL_DURATION_TIME = SUM(ASAVST.[DurationTime] + ASAVST.[AlreadyDurationTime]),
				@TOTAL_VALID_DURATION_TIME = SUM(CASE WHEN (ASAVST.[ValidDurationTime] + ASAVST.[AlreadyTranscribedDurationTime]) > 60 
												THEN (ASAVST.[ValidDurationTime] + ASAVST.[AlreadyTranscribedDurationTime])
												ELSE 60 END), 
				@TOTAL_ROUNDED_DURATION_TIME = SUM(CASE WHEN (ASAVST.[RoundedDurationTime] + ASAVST.[AlreadyTranscribedRoundedDurationTime]) > 60 
													THEN (ASAVST.[RoundedDurationTime] + ASAVST.[AlreadyTranscribedRoundedDurationTime]) 
													ELSE 60 END), 
				@TOTAL_VALID_REQUEST = SUM(CASE WHEN (ASAVDT.[TotalValidRequest] + ASAVDT.[TotalInvalidRequest]) < (ASAVST.[TotalAudio]) 
											THEN ASAVST.[TotalAudio] 
											ELSE (ASAVDT.[TotalValidRequest] + ASAVDT.[TotalInvalidRequest]) END)
			FROM [dbo].[AccountSubAccountVCCSummaryTransaction] ASAVST (NOLOCK) 
			INNER JOIN [dbo].[AccountSubAccountVCCDetailedTransaction] ASAVDT (NOLOCK) 
				ON ASAVDT.[InstallationId] = ASAVST.[InstallationId]
					AND ASAVDT.[BatchId] = ASAVST.[BatchID]
					AND ASAVDT.[SystemService] = ASAVST.[SystemService]
			WHERE ASAVST.[InstallationId] = @InstallationId
				AND ASAVST.[VCC] = @VCC 
				AND ASAVST.[SystemService] = 'COGNITIVE_ANALYSIS'
				AND ASAVDT.[Description] = 'SUCCED'
				AND ASAVST.[CreatedDate] >= '2020-05-01T00:00:00Z'

		/*
		SELECT @TOTAL_AUDIOS 'audios', 
				@TOTAL_VALID_REQUEST 'requests', 
				@TOTAL_DURATION_TIME 'durationTime',
				@TOTAL_VALID_DURATION_TIME 'validTime', 
				@TOTAL_ROUNDED_DURATION_TIME 'roundedTime', 
				(60.00 * @TOTAL_VALID_REQUEST) / @TOTAL_VALID_DURATION_TIME 'validTimeAverage',
				(60.00 * @TOTAL_VALID_REQUEST) / @TOTAL_ROUNDED_DURATION_TIME 'roundedTimeAverage'
		*/
			
		-- VALIDAMOS QUE LOS VALORES SEAN VALIDOS
		IF @TOTAL_AUDIOS IS NULL OR @TOTAL_AUDIOS = 0 
			OR @TOTAL_DURATION_TIME IS NULL OR @TOTAL_DURATION_TIME = 0 
			OR @TOTAL_VALID_DURATION_TIME IS NULL OR @TOTAL_VALID_DURATION_TIME = 0 
			OR @TOTAL_ROUNDED_DURATION_TIME IS NULL OR @TOTAL_ROUNDED_DURATION_TIME = 0
			OR @TOTAL_VALID_REQUEST  IS NULL OR @TOTAL_VALID_REQUEST = 0
		BEGIN
			-- TOMAMOS EL VALOR POR DEFECTO (O VALOR BASE) PARA SEGUNDOS POR REQUEST
			SET @SECONDS_PER_REQUEST = 30

			-- TOMAMOS EL VALOR POR DEFECTO (O VALOR BASE) PARA REQUEST POR MINUTO
			SET @REQUEST_PER_MINUTE = 2
		END
		ELSE
		BEGIN
			-- CALCULAMOSEL VALOR PROMEDIO DE SEGUNDOS POR REQUEST SEGUN EL HISTORICO
			SET @SECONDS_PER_REQUEST = @TOTAL_DURATION_TIME / @TOTAL_VALID_REQUEST

			-- CALCULAMOS EL VALOR PROMEDIO DE REQUEST POR MINUTO SEGUN EL HISTORICO
			--SET @REQUEST_PER_MINUTE = CEILING ((60.00 * @TOTAL_VALID_REQUEST) / @TOTAL_VALID_DURATION_TIME)
			SET @REQUEST_PER_MINUTE = (60.00 * @TOTAL_VALID_REQUEST) / @TOTAL_VALID_DURATION_TIME
			--SET @REQUEST_PER_MINUTE = CEILING ((60.00 * @TOTAL_VALID_REQUEST) / @TOTAL_ROUNDED_DURATION_TIME)
		END

		-- INSERTAMOS EL NUEVO PROMEDIO DE REQUEST EN LA TABLA HISTORICA
		INSERT INTO [dbo].[CognitiveAnalysisHistory] 
			([InstallationId], [VCC], [AverageRequestPerMinute])
		VALUES (@InstallationId, @VCC, @REQUEST_PER_MINUTE)
		
		-- RECUPERAMOS EL VALOR DE REQUEST PROMEDIO POR MINUTO
		SELECT @SECONDS_PER_REQUEST 'CAASPR', 
				@REQUEST_PER_MINUTE 'CAARPM', 
				@COGNITIVE_ANALYSIS_BILLING_SECURE_RATE 'CABSR'

	END TRY
    BEGIN CATCH
        -- IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

	SET XACT_ABORT, NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[AccountSubAccountVCCBatchSummaryCreate]...';


GO

ALTER PROCEDURE [dbo].[AccountSubAccountVCCBatchSummaryCreate] (
	@PlatformHash VARCHAR(100) = NULL,
	@InstallationId VARCHAR(50) = NULL,
	@AccountId VARCHAR(50) = NULL,
	@SubAccountId VARCHAR(50) = NULL,
	@VCC VARCHAR(50) = NULL,
	@TotalInteraction INT = 0,							-- TOTAL DE INTERACCIONES DE BATCH(SINCRONAS + ASINCRONAS)
	@TotalAsync INT = 0,								-- TOTAL DE INTERACCIONES ASINCRONAS(OTROS CANALES)
	@TotalAsyncDetail INT = 0,							-- TOTAL DE DETALLES DE INTERACCIONES ASINCRONAS
	@EstimatedNewTextPhrases DECIMAL(18, 5) = 0,		-- TOTAL DE FRASES TEXT ESTIMADAS PARA EL BATCH ACTUAL(SU FINALIDAD ES LA RETENCION)
	@AlreadyTextPhrases INT = 0,						-- TOTAL DE FRASES TEXT YA GENERADAS EN OTRO PROCESS
	@RawChar INT = 0,									-- TOTAL BRUTO DE CARACTERES DEL PRESENTE BATCH(TODOS)
	@InProcessAsyncDetail INT = 0,						-- CANTIDAD DE ASYNCDETAIL YA PRESENTES EN OTROS BATCH
	@InProcessRawChar INT = 0,							-- TOTAL BRUTO DE CARACTERES YA PRESENTES EN OTROS BATCH EN CURSO
	@AlreadyTranscribedAsyncDetail INT = 0,				-- CANTIDAD DE ASYNCDETAIL YA TRANSCRITOS EN OTROS BATCH EN CURSO
	@AlreadyTranscribedRawChar INT = 0,					-- TOTAL BRUTO DE CARACTERES PRESENTES EN OTROS BATCH YA TRANSCRITOS
	@AlreadyTranscribedValidChar INT = 0,				-- TOTAL CARACTERES VALIDOS PRESENTES EN OTROS BATCH YA TRANSCRITOS
	@TotalSync INT = 0,									-- TOTAL DE INTERACCIONES SINCRONAS(CALL)
	@TotalAudio int = 0,								-- CANTIDAD DE AUDIOS DEL PRESENTE BATCH
	@EstimatedNewCallPhrases DECIMAL(18, 5) = 0,		-- TOTAL DE FRASES CALL ESTIMADAS PARA EL BATCH ACTUAL(SU FINALIDAD ES LA RETENCION)
	@AlreadyCallPhrases INT = 0,						-- TOTAL DE FRASES CALL YA GENERADAS EN OTRO PROCESS
	@DurationTime int = 0,								-- TIEMPO BRUTO DE LOS AUDIOS DEL PRESENTE BATCH
	@RoundedDurationTime int = 0,						-- TIEMPO REDONDEADO BRUTO DE LOS AUDIOS DEL PRESENTE BATCH
	@InProcessAudio int = 0,							-- CANTIDAD DE AUDIOS YA PRESENTES EN OTROS BATCH
	@InProcessDurationTime int = 0,						-- TIEMPO BRUTO DE LOS AUDIOS YA PRESENTES EN OTROS BATCH
	@AlreadyTranscribedAudio int = 0,					-- CANTIDAD DE AUDIOS YA TRANSCRITOS EN OTROS BATCH
	@AlreadyDurationTime int = 0,						-- TIEMPO BRUTO YA TRANSCRITO
	@AlreadyRoundedDurationTime int = 0,				-- TIEMPO REDODNEADO BRUTO YA TRANSCRITO
	@AlreadyTranscribedDurationTime int = 0,			-- TIEMPO TRANCRITO
	@AlreadyTranscribedRoundedDurationTime int = 0,		-- TIEMPO REDONDEADO YA TRANSCRITO
	@TotalQueries int = 0,
	@TotalModels DECIMAL(18, 5) = 0,
	@ModelRequests DECIMAL(18, 5) = 0,					-- CANTIDAD ESTIMADA DE REQUESTS POR MODELO(INCLUYE CALL Y TEXT + MARGEN DE SEGURIDAD)
	@BatchTypeName VARCHAR(50) = NULL,
	@BatchTypeId VARCHAR(50) = NULL,
	@ProcessId VARCHAR(100) = NULL,
	@TemplateId VARCHAR(100) = NULL,
	@UserApi VARCHAR(50) = NULL,
	@StartDate DateTime = NULL
) AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR LOS SALDOS DE LAS CARTERAS DEL VCC
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY

		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

		-- VERIFICAMOS QUE TENEMOS LOS PARAMETROS NECESARIOS
		IF @PlatformHash IS NULL 
			OR @InstallationId IS NULL 
			OR @AccountId IS NULL 
			OR @VCC IS NULL
			OR @UserApi IS NULL
			-- LANZAMOS MENSAJE AVISANDO QUE FALTA ACCOUNTID
			RAISERROR('DATABABASE_ERROR_MISSING_PARAMETERS', 16, 16)

		-- TOCA VALIDAR QUE EXISTE EL PLATFORMHASH Y ESTA ACTIVO
		-- TOCA VALIDAR QUE EXISTE EL ACCOUNT
		-- TOCA VALIDAR QUE EXISTE EL SUBACCOUNT
		-- TOCA VALIDAR QUE EXISTE EL VCC
		-- TOCA VALIDAD QUE EXISTE EL USERAPI

		-- VERIFICAMOS QUE EL BATCH TYPE SEA UN TIPO CONOCIDO DEL SISTEMA
		IF @BatchTypeName <> 'EVALUATION_PLAN' AND @BatchTypeName <> 'TRANSCRIPTION' AND @BatchTypeName <> 'STUDY'
			-- LANZAMOS MENSAJE AVISANDO QUE HAN SOLICITADO UNA OPERACION DESCONOCIDA
			RAISERROR('DATABABASE_ERROR_UNKNOWN_BATCH_TYPE', 16, 16)

		-- VERIFICAMOS QUE EL BATCH RECIBIDO NO EXISTA YA EN LA BASE DE DATOS
		IF EXISTS(
			SELECT ASAVST.[BatchTypeId] 
				FROM [dbo].[AccountSubAccountVCCSummaryTransaction] ASAVST (NOLOCK)
				WHERE ASAVST.[InstallationId] = @InstallationId
					AND ASAVST.[VCC] =  @VCC
					AND ASAVST.[BatchTypeName] = @BatchTypeName
					AND ASAVST.[BatchTypeId] =  @BatchTypeId
		)
			-- LANZAMOS MENSAJE AVISANDO QUE FALTA ACCOUNTID
			RAISERROR('DATABABASE_ERROR_DUPLICATE_BATCHTYPEID', 16, 16)
		
		-- DECLARAMOS VARIABLES TIPO BIT QUE NOS INDIQUEN LOS SERVICIOS DEL SISTEMA QUE REGISTRAREMOS
		DECLARE @TRANSCRIPTION BIT = 0
		DECLARE @SEMANTIC_ANALYSIS BIT = 0
		DECLARE @COGNITIVE_ANALYSIS BIT = 0
		DECLARE @VALID_DURATION_TIME INT = 0
		DECLARE @ROUNDED_VALID_DURATION_TIME INT = 0
		DECLARE @VALID_CHAR INT = 0

		-- SEGUN LOS DATOS RECIBIDOS DETERMINAMOS QUE SERVICIO DEL SISTEMA ESTA INCLUIDO EN EL BATCH
		IF @DurationTime > 0 OR @TotalAsyncDetail > 0 SET @TRANSCRIPTION = 1
		IF @TotalQueries > 0 SET @SEMANTIC_ANALYSIS = 1
		IF @TotalModels > 0 SET @COGNITIVE_ANALYSIS = 1

		-- VALIDAMOS QUE AL MENOS UNO DE LOS SERVICIOS DEL SISTEMA SEA CONSUMIDO PRO EL BATCH
		IF @TRANSCRIPTION = 0 AND @SEMANTIC_ANALYSIS = 0 AND @COGNITIVE_ANALYSIS = 0
			-- LANZAMOS MENSAJE AVISANDO QUE HAN SOLICITADO UNA OPERACION DESCONOCIDA
			RAISERROR('DATABABASE_ERROR_NO_SYSTEM_SERVICE', 16, 16)

		-- DECLARAMOS VARIABLES TIPO DECIMAL PARA ALMACENAR LAS TARIFAS DE SERVICIOS SETTEADAS PARA EL VCC
		DECLARE @TRANSCRIPTION_RATE_PER_SECOND DECIMAL(18,5) = 0
		DECLARE @SEMANTIC_ANALYSIS_RATE_PER_SECOND DECIMAL(18,5) = 0
		DECLARE @COGNITIVE_ANALYSIS_RATE_PER_SECOND DECIMAL(18,5) = 0

		-- BUSCAMOS LA TARIFAS DE LOS SERVICIOS DEL SISTEMA PARA EL VCC INGRESADO
		SELECT @TRANSCRIPTION_RATE_PER_SECOND = AV.[TranscriptionRatePerSecond],
				@SEMANTIC_ANALYSIS_RATE_PER_SECOND = AV.[SemanticAnalysisRatePerTransaction],
				@COGNITIVE_ANALYSIS_RATE_PER_SECOND = AV.[CognitiveAnalysisRatePerTransaction]
			FROM [dbo].[AccountVCC] AV (NOLOCK)
			WHERE AV.[InstallationId] = @InstallationId
				AND AV.[VCC] = @VCC 

		-- DECLARAMOS UNA VARIABLE PARA EL IDENTIFICADOR UNICO DEL BATCH
		DECLARE @ID VARCHAR(100) = NEWID()

		-- DECLARAMOS UNA VARIABLE INT PARA CONTABILIZAR LOS PASOS PARA EL REGISTRO DE MOVIMIENTOS
		DECLARE @BATCH_TOTAL_STEPS INT = 0

		-- DECLARAMOS UNA VARIABLE PARA INDICAR EL PASO ACTUAL EN QUE NOS ENCONTRAMOS
		DECLARE @BATCH_CURRENT_STEP INT = 0 

		-- DECLARAMOS UNA VARIABLE VARCHAR PARA CONCATENAR LOS SERVICIOS DEL SISTEMA INCLUIDOS EN EL BATCH
		DECLARE @BATCH_SYSTEM_SERVICES VARCHAR(100) = ''
		
		-- CONCATENAMOS LOS SERVICIOS DEL SISTEMA Y ACUMULMOS EL TOTAL DE PASOS PARA EL REGISTRO DE MOVIMIENTOS (SERVICIOS ASOCIADOS * 3 <- RETAIN, DEBT, RELEASE)
		IF @TRANSCRIPTION = 1
		BEGIN
			SET @BATCH_TOTAL_STEPS = @BATCH_TOTAL_STEPS + (1 * 3)
			SET @BATCH_SYSTEM_SERVICES = CONCAT(@BATCH_SYSTEM_SERVICES, 'TRANSCRIPTION,')
		END

		IF @SEMANTIC_ANALYSIS = 1 
		BEGIN 
			SET @BATCH_TOTAL_STEPS = @BATCH_TOTAL_STEPS + (1 * 3)
			SET @BATCH_SYSTEM_SERVICES = CONCAT(@BATCH_SYSTEM_SERVICES, 'SEMANTIC_ANALYSIS,')
		END
		
		IF @COGNITIVE_ANALYSIS = 1 
		BEGIN 
			SET @BATCH_TOTAL_STEPS = @BATCH_TOTAL_STEPS + (1 * 3)
			SET @BATCH_SYSTEM_SERVICES = CONCAT(@BATCH_SYSTEM_SERVICES, 'COGNITIVE_ANALYSIS,')
		END

		-- DECLARAMOS LA VARIABLE EN LA QUE ESCRIBIREMOS LA DESCRIPCION DEL MOVIMIENTO
		DECLARE @MOVEMENT_DESCRIPTION VARCHAR(250) = NULL

		-- DECLARAMOS UNA VARIABLE VARCHAR PARA ALMACENAR EL SERVICIO DEL SISTEMA RECORRIDO
		DECLARE @CURRENT_SYSTEM_SERVICE VARCHAR(50) = ''

		-- DECLARAMOS UNA VARIABLE DECIMAL PARA ALMACENAR EL SALDO RETENIDO RECORRIDO
		DECLARE @CURRENT_RETAINED_AMOUNT DECIMAL(18,5) = 0

		-- DECLARAMOS UNA VARIABLE DECIMAL PARA ALMACENAR EL TOTAL DE REQUEST ESTIMADOS CON % DE SEGURIDAD INCLUIDO
		DECLARE @CURRENT_TOTAL_ESTIMATED_MODEL_REQUESTS DECIMAL(18,5) = 0
		
		-- DECLARAMOS UNA VARIABLE PARA ALMACENAR EL SPLIT DE SERVICIOS
		DECLARE MY_CURSOR CURSOR 
		LOCAL STATIC READ_ONLY FORWARD_ONLY
			FOR 
			SELECT Value FROM [dbo].[split](@BATCH_SYSTEM_SERVICES, ',')

		-- ABRIMOS Y RECORREMOS EL ARRAY DE PRODUCTOS
		OPEN MY_CURSOR
		FETCH NEXT FROM MY_CURSOR INTO @CURRENT_SYSTEM_SERVICE
		WHILE @@FETCH_STATUS = 0
		BEGIN 
			-- VALIDAMOS QUE NO SEA UNA VARIABLE VACIA
			IF @CURRENT_SYSTEM_SERVICE <> ''
			BEGIN
				-- SETTEAMOS EL MONTO RETENIDO ACTUAL
				IF @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION' 
				BEGIN
					-- EN CASO DURATIONTIME SEA NULL
					IF @DurationTime IS NULL SET @DurationTime = 0
					IF @InProcessDurationTime IS NULL SET @InProcessDurationTime = 0
					IF @AlreadyDurationTime IS NULL SET @AlreadyDurationTime = 0

					SET @CURRENT_RETAINED_AMOUNT = @TRANSCRIPTION_RATE_PER_SECOND * (@DurationTime - @InProcessDurationTime - @AlreadyDurationTime)
				END

				IF @CURRENT_SYSTEM_SERVICE IN ('SEMANTIC_ANALYSIS', 'COGNITIVE_ANALYSIS')
				BEGIN
					-- DEPENDIENDO DEL TIPO DE BATCH TOMAMOS EL TIEMPO DE DIFERENTE FORMA
					IF @BatchTypeName = 'STUDY'
					BEGIN
						-- RECUPERAMOS EL DURATIONTIME USANDO EL PROCESSID
						SELECT @TotalAsyncDetail = (ASAVST.[ValidTotalAsyncDetail] + ASAVST.[AlreadyTranscribedAsyncDetail]),
								@RawChar = (ASAVST.[RawChar] + ASAVST.[AlreadyTranscribedRawChar]),
								@VALID_CHAR = (ASAVST.[ValidChar] + ASAVST.[AlreadyTranscribedValidChar]),
								@TotalAudio = (ASAVST.[ValidTotalAudio] + ASAVST.[AlreadyTranscribedAudio]),
								@DurationTime = (ASAVST.[DurationTime] + ASAVST.[AlreadyDurationTime]),
								@VALID_DURATION_TIME = (ASAVST.[ValidDurationTime] + ASAVST.[AlreadyTranscribedDurationTime]),
								@ROUNDED_VALID_DURATION_TIME = (ASAVST.[RoundedDurationTime] + ASAVST.[AlreadyTranscribedRoundedDurationTime])
							FROM [dbo].[AccountSubAccountVCCSummaryTransaction] ASAVST (NOLOCK) 
							WHERE ASAVST.[InstallationId] = @InstallationId
								AND ASAVST.[VCC] = @Vcc
								AND ASAVST.[BatchTypeName] = 'TRANSCRIPTION'
								AND ASAVST.[BatchTypeID] = @ProcessId

						-- SI ESTAMOS CREANDO ESTUDIO, NO NECESITAMOS EL DURATIONTIME PORQUE YA TENEMOS EL VALIDDURATIONTIME
					END
					ELSE IF @BatchTypeName = 'EVALUATION_PLAN'
					BEGIN 
						SET @DurationTime = @DurationTime
						SET @ROUNDED_VALID_DURATION_TIME = @RoundedDurationTime
						SET @AlreadyDurationTime = @AlreadyDurationTime
						SET @AlreadyRoundedDurationTime = @AlreadyRoundedDurationTime
					END

					IF @CURRENT_SYSTEM_SERVICE = 'SEMANTIC_ANALYSIS' SET @CURRENT_RETAINED_AMOUNT = @SEMANTIC_ANALYSIS_RATE_PER_SECOND * @TotalQueries

					IF @CURRENT_SYSTEM_SERVICE = 'COGNITIVE_ANALYSIS'
					BEGIN
						-- DECLARAMOS UN FLAG PARA INDICAR SI ES UN PROCESS PREVIO A LA IMPLEMENTACION DE CANALES
						DECLARE @IS_POST_CHANNEL BIT = 0

						IF EXISTS (
							SELECT TOP 1 1 
								FROM [dbo].[AccountSubAccountVCCSummaryTransaction] ASAVST (NOLOCK), [dbo].[GeneralSecureRate] GSR (NOLOCK)
								WHERE ASAVST.[BatchTypeName] = 'TRANSCRIPTION'
									AND ASAVST.[EndDate] > GSR.[CreatedDate]
									AND ASAVST.[BatchTypeId] = @ProcessId
						)
							SET @IS_POST_CHANNEL = 1

						-- *TASA DE SEGURO DE FACTURACION: SI SE CAMBIA ESTE VALOR, SE DEBERA CAMBIAR TAMBIEN EN EL SP [dbo].[AccountSubAccountVCCBatchSummaryCreate]
						DECLARE @COGNITIVE_ANALYSIS_BILLING_SECURE_RATE DECIMAL(5, 2) = 0 
						DECLARE @COGNITIVE_ANALYSIS_TEXT_BILLING_SECURE_RATE DECIMAL(5, 2) = 0 

						-- RECUPERAMOS LAS TASAS DE SEGURIDAD DE LA TABLA CORRESPONDIENTE(ESTE BLOQUE SE BORRARA, LA FUNCIONALIDAD ACTUALIZADA HACE LA DISCRIMINACION AUTOMATICAMENTE)
						SELECT TOP 1 @COGNITIVE_ANALYSIS_BILLING_SECURE_RATE  = GSR.[QualityCallCognitiveAnalysisSecureRate],
										@COGNITIVE_ANALYSIS_TEXT_BILLING_SECURE_RATE = GSR.[QualityTextCognitiveAnalysisSecureRate]
							FROM [dbo].[GeneralSecureRate] GSR (NOLOCK)

						-- SEGUIMOS SEGUN EL PROCESS ES PREVIO O NO A LA IMPLMENTACION DE CANALES(2020-07)
						-- IF @IS_POST_CHANNEL = 1
						IF @BatchTypeName = 'STUDY'
						BEGIN
							SET @CURRENT_RETAINED_AMOUNT = CEILING(@TotalModels * @COGNITIVE_ANALYSIS_RATE_PER_SECOND * @ModelRequests) 
							/*
							SET @CURRENT_RETAINED_AMOUNT = CEILING(
																	@TotalModels 
																	*
																	@COGNITIVE_ANALYSIS_RATE_PER_SECOND
																	*
																	(
																		((@EstimatedNewCallPhrases + @AlreadyCallPhrases) * (1 + @COGNITIVE_ANALYSIS_BILLING_SECURE_RATE))
																		+
																		((@EstimatedNewTextPhrases + @AlreadyTextPhrases) * (1 + @COGNITIVE_ANALYSIS_TEXT_BILLING_SECURE_RATE))
																	)
															)
							*/

							SET @CURRENT_TOTAL_ESTIMATED_MODEL_REQUESTS = CEILING(@TotalModels * @ModelRequests)
						END
						ELSE
						BEGIN 
							-- DECLARAMOS UNA TABLE PARA ALMACENAR EL RESULTADO DEL SP
							DECLARE @SP_RESULT AS TABLE ([CAASPR] DECIMAL(5, 2), [CAARPM] DECIMAL(5, 2), [CABSR] DECIMAL(5, 2))

							-- EJECUTAMOS EL SP QUE GENERA EL NUMERO DE REQUEST PROMEDIO POR MINUTO
							INSERT @SP_RESULT EXEC [dbo].[GetCognitiveAnalysisAverageRequestPerMinute] @InstallationId, @Vcc 
							--EXEC [dbo].[GetCognitiveAnalysisAverageRequestPerMinute] @InstallationId, @Vcc 

							DECLARE @AVERAGE_COGNITIVE_ANALYSIS_SECONDS_PER_REQUEST DECIMAL(5, 2) = 0
							DECLARE @AVERAGE_COGNITIVE_ANALYSIS_REQUEST_PER_MINUTE DECIMAL(5, 2) = 0
							DECLARE @DUMMY_VAR DECIMAL(5, 2) = 0
							
							-- RECUPERAMOS LOS DATOS DE REQUEST PROMEDIO Y TASA DE SEGURIDAD RECUPERADAS EN EL SP
							SELECT TOP 1 @AVERAGE_COGNITIVE_ANALYSIS_SECONDS_PER_REQUEST = SPR.[CAASPR],
									@AVERAGE_COGNITIVE_ANALYSIS_REQUEST_PER_MINUTE = SPR.[CAARPM],
									@DUMMY_VAR = SPR.[CABSR] -- <- ESTO SE BORRARA
								FROM @SP_RESULT SPR 

							-- CALCULAMOS EL MONTO PARA ANALISIS COGNITIVO DE LA SIGUIENTE FORMA:
							-- TOTAL MODELS * TARIFA POR TRANSACCION * (TIEMPO TRANSCRITO O TIEMPO TOTAL * PROMEDIO DE REQUEST POR MINUTO / 60) * (1 + TASA DE SEGURO DE FACTURACION)
							-- *TASA DE SEGURO DE FACTURACION: SI SE CAMBIA ESTE VALOR, SE DEBERA CAMBIAR TAMBIEN EN EL SP [dbo].[GetAccountVccRates]
							-- SET @CURRENT_RETAINED_AMOUNT = (@TotalModels * @COGNITIVE_ANALYSIS_RATE_PER_SECOND * @DurationTime * @AVERAGE_COGNITIVE_ANALYSIS_REQUEST_PER_MINUTE * (1 + @COGNITIVE_ANALYSIS_BILLING_SECURE_RATE)) / 60
							-- SET @CURRENT_RETAINED_AMOUNT = CEILING((@TotalModels * @COGNITIVE_ANALYSIS_RATE_PER_SECOND * @ROUNDED_VALID_DURATION_TIME * @AVERAGE_COGNITIVE_ANALYSIS_REQUEST_PER_MINUTE * (1 + @COGNITIVE_ANALYSIS_BILLING_SECURE_RATE)) / 60)
							-- SET @CURRENT_RETAINED_AMOUNT = @TotalModels * CEILING(@COGNITIVE_ANALYSIS_RATE_PER_SECOND * @DurationTime * (1 + @COGNITIVE_ANALYSIS_BILLING_SECURE_RATE) / @AVERAGE_COGNITIVE_ANALYSIS_SECONDS_PER_REQUEST) 
							-- SET @CURRENT_RETAINED_AMOUNT = CEILING(@TotalModels * @COGNITIVE_ANALYSIS_RATE_PER_SECOND * @ModelRequests * (1 + @COGNITIVE_ANALYSIS_BILLING_SECURE_RATE)) 
							SET @CURRENT_RETAINED_AMOUNT = CEILING(
																	@TotalModels 
																	*
																	@COGNITIVE_ANALYSIS_RATE_PER_SECOND
																	*
																	(
																		((@EstimatedNewCallPhrases + @AlreadyCallPhrases) * (1 + @COGNITIVE_ANALYSIS_BILLING_SECURE_RATE))
																		+
																		((@EstimatedNewTextPhrases + @AlreadyTextPhrases) * (1 + @COGNITIVE_ANALYSIS_TEXT_BILLING_SECURE_RATE))
																	)
															)
							SET @CURRENT_TOTAL_ESTIMATED_MODEL_REQUESTS = CEILING(@TotalModels * @ModelRequests)
						END					
					END 
				END
				
				--VERIFICAMOS QUE TENEMOS SALDO SUFICIENTE EN LA CARTERA DE TRANSCRICIOPNES DEL VCC
				IF NOT EXISTS (SELECT AVB.[AccountId] 
							FROM [dbo].[AccountVccBalance] AVB (NOLOCK)
							WHERE AVB.[InstallationId] = @InstallationId
								AND AVB.[AccountId] = @AccountID
								AND AVB.[VCC] = @VCC
								AND AVB.[SystemService] = @CURRENT_SYSTEM_SERVICE
								AND AVB.[AvailableBalance] >= @CURRENT_RETAINED_AMOUNT)
					-- SI NO ENCUENTRA RESULTADO, LANZAMOS MENSAJE AVISANDO NO HAY SUFICIENTE SALDO PARA TRANSCRIPCIONES
					RAISERROR('DATABABASE_ERROR_INSUFFICIENT_SYSTEM_SERVICE_BALANCE', 16, 16)

				-- BLOQUEMOS TEMPORALMENTE EL REGISTRO DE SALDOS DEL SERVICO USANDO LOS MISMO PARAMETROS DE BUSQUEDA Y 
				-- ASEGURANDONOS QUE EL SALDO DISPONIBLE AUN ES MAYOR QUE EL SALDO A SETTEAR
				UPDATE [dbo].[AccountVccBalance] 
					SET [IsLocked] = 1,
						[LastModifiedByUserId] = @UserApi,
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [InstallationId] = @InstallationId
						AND [AccountId] = @AccountID
						AND [VCC] = @VCC
						AND [SystemService] = @CURRENT_SYSTEM_SERVICE
						AND [AvailableBalance] >= @CURRENT_RETAINED_AMOUNT
			
				IF @@ROWCOUNT = 0
					RAISERROR('DATABABASE_ERROR_INSUFFICIENT_SYSTEM_SERVICE_BALANCE', 16, 16)

				-- UNA VEZ BLOQUEADO EL REGISTRO DE LA TABLA ACCOUNTVCCBALANCE, REGISTRAMOS LAS SALIDAS Y ENTRADAS EN 
				-- LA TABLA DE MOVIMIENTOS ACCOUNSUBACCOUNTVCCBALANCEMOVEMENT (MOVIMIENTO DE SERVICIO TARGET -> FREE)
				-- DEFINIMOS LA DESCRIPCION DEL MOVIMIENTO PARA ESTE BLOQUE
				SET @MOVEMENT_DESCRIPTION = CONCAT('VCC ', @VCC, ': RETAIN $', @CURRENT_RETAINED_AMOUNT, ' FROM ', @CURRENT_SYSTEM_SERVICE, ' WALLET ON CREATING BATCH') 

				-- INCREMENTAMOS EN 1 EL PASO EN QUE NOS ENCONTRAMOS
				SET @BATCH_CURRENT_STEP = @BATCH_CURRENT_STEP + 1

				-- INSERTAMOS EN LA TABLA ACCOUNSUBACCOUNTVCCBALANCEMOVEMENT EL REGISTRO PARA LA RETENCION DE LA CARTERA TRANSCRIPTION
				INSERT INTO [dbo].[AccountSubAccountVCCBalanceMovement] 
							([ID] ,[InstallationId] ,[AccountId] ,[SubAccountId] ,[VCC]
							,[Wallet] ,[Type] ,[CurrentStep] ,[TotalSteps] ,[Description]
							,[BatchId] ,[Amount]
							,[PrevAvailableBalance] ,[PostAvailableBalance] 
							,[PrevCountableBalance] ,[PostCountableBalance] 
							,[TimeStamp])
					SELECT @ID ,AVB.[InstallationId] ,AVB.[AccountId] ,AVB.[SubAccountId] ,AVB.[VCC]
							,AVB.[SystemService] ,'RETAIN' ,@BATCH_CURRENT_STEP ,@BATCH_TOTAL_STEPS ,@MOVEMENT_DESCRIPTION
							,@ID ,@CURRENT_RETAINED_AMOUNT
							,AVB.[AvailableBalance] ,AVB.[AvailableBalance] - @CURRENT_RETAINED_AMOUNT 
							,AVB.[CountableBalance] ,AVB.[CountableBalance]
							,GETUTCDATE()
						FROM [dbo].[AccountVCCBalance] AVB (NOLOCK)
						WHERE [InstallationId] = @InstallationId 
							AND [AccountId] = @AccountId
							AND [VCC] = @VCC
							AND [SystemService] = @CURRENT_SYSTEM_SERVICE
							AND [AvailableBalance] > @CURRENT_RETAINED_AMOUNT

				-- VARIAMOS EL INSERT SEGUN EL SERVICIO DEL SISTEMA
				IF @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION'
				BEGIN
					-- INSERTAMOS EL PAQUETE DE TRANSCRIPCION EN LA TABLA GENERAL DE TRANSACCION
					INSERT INTO [dbo].[AccountSubAccountVCCSummaryTransaction] (
						[BatchID] ,[InstallationId] ,[VCC] ,[SystemService] ,[TotalInteraction]
						,[TotalAsync] ,[TotalAsyncDetail] ,[AlreadyTextPhrases] ,[TotalSync] ,[TotalAudio] 
						,[AlreadyCallPhrases] ,[DurationTime] ,[AlreadyTranscribedAudio] ,[AlreadyDurationTime] ,[AlreadyRoundedDurationTime] 
						,[AlreadyTranscribedDurationTime] ,[AlreadyTranscribedRoundedDurationTime] ,[TranscriptionRatePerSecond] ,[BatchTypeName] ,[BatchTypeId] 
						,[ProcessId] ,[UserApi] ,[StartDate] ,[CreatedDate] ,[CreatedByuserId] 
						,[TimeStamp]
					)
					VALUES (
						@ID ,@InstallationId ,@VCC ,@CURRENT_SYSTEM_SERVICE ,@TotalInteraction
						,@TotalAsync ,@TotalAsyncDetail ,@AlreadyTextPhrases ,@TotalSync ,@TotalAudio 
						,@AlreadyCallPhrases ,@DurationTime ,@AlreadyTranscribedAudio ,@AlreadyDurationTime ,@AlreadyRoundedDurationTime 
						,@AlreadyTranscribedDurationTime ,@AlreadyTranscribedRoundedDurationTime ,@TRANSCRIPTION_RATE_PER_SECOND ,@BatchTypeName ,@BatchTypeId 
						,@ProcessId ,@UserApi ,@StartDate ,GETUTCDATE() , @UserApi 
						,GETUTCDATE()
					)
			
					-- LANZAMOS MENSAJE DE ERROR SI HUBO FALLA AL INSERTAR EL PAQUETE DE TRANSCRIPCION
					IF @@ROWCOUNT = 0
						RAISERROR('DATABABASE_ERROR_TRANSCRIPTION_SERVICE_PACKAGE_SAVE_FAILED', 16, 16)
				END 

				IF @CURRENT_SYSTEM_SERVICE = 'SEMANTIC_ANALYSIS' 
				BEGIN
					-- INSERTAMOS EL PAQUETE DE TRANSCRIPCION EN LA TABLA GENERAL DE TRANSACCION
					INSERT INTO [dbo].[AccountSubAccountVCCSummaryTransaction] (
						[BatchID] ,[InstallationId] ,[VCC] ,[SystemService] ,[TotalAudio] 
						,[ValidDurationTime] ,[DurationTime] ,[RoundedDurationTime] ,[TotalQueries] ,[SemanticAnalysisRatePerTransaction] 
						,[BatchTypeName] ,[BatchTypeId] ,[ProcessId] ,[TemplateId] ,[UserApi] 
						,[StartDate] ,[CreatedDate] ,[CreatedByuserId] ,[TimeStamp]
					)
					VALUES (
						@ID ,@InstallationId ,@VCC ,@CURRENT_SYSTEM_SERVICE ,@TotalAudio 
						,@VALID_DURATION_TIME ,@DurationTime, @ROUNDED_VALID_DURATION_TIME ,@TotalQueries ,@SEMANTIC_ANALYSIS_RATE_PER_SECOND 
						,@BatchTypeName ,@BatchTypeId ,@ProcessId ,@TemplateId ,@UserApi 
						,@StartDate ,GETUTCDATE() ,@UserApi ,GETUTCDATE()
					)
			
					-- LANZAMOS MENSAJE DE ERROR SI HUBO FALLA AL INSERTAR EL PAQUETE DE TRANSCRIPCION
					IF @@ROWCOUNT = 0
						RAISERROR('DATABABASE_ERROR_SEMANTIC_ANALYSIS_SERVICE_PACKAGE_SAVE_FAILED', 16, 16)
				END
				
				IF @CURRENT_SYSTEM_SERVICE = 'COGNITIVE_ANALYSIS' 
				BEGIN
					-- INSERTAMOS EL PAQUETE DE TRANSCRIPCION EN LA TABLA GENERAL DE TRANSACCION
					INSERT INTO [dbo].[AccountSubAccountVCCSummaryTransaction] (
						[BatchID] ,[InstallationId] ,[VCC] ,[SystemService] ,[TotalAudio] 
						,[ValidDurationTime] ,[DurationTime] ,[RoundedDurationTime] ,[TotalModels] ,[EstimatedRequestsPerModel]
						,[EstimatedModelRequests] ,[CognitiveAnalysisRatePerTransaction] ,[BatchTypeName] ,[BatchTypeId] ,[ProcessId] 
						,[TemplateId] ,[UserApi] ,[StartDate] ,[CreatedDate] ,[CreatedByuserId] 
						,[TimeStamp]
					)
					VALUES (
						@ID ,@InstallationId ,@VCC ,@CURRENT_SYSTEM_SERVICE ,@TotalAudio 
						,@VALID_DURATION_TIME ,@DurationTime ,@ROUNDED_VALID_DURATION_TIME ,@TotalModels ,@ModelRequests
						,@CURRENT_TOTAL_ESTIMATED_MODEL_REQUESTS ,@COGNITIVE_ANALYSIS_RATE_PER_SECOND ,@BatchTypeName ,@BatchTypeId ,@ProcessId 
						,@TemplateId ,@UserApi ,@StartDate ,GETUTCDATE() ,@UserApi 
						,GETUTCDATE()
					)
			
					-- LANZAMOS MENSAJE DE ERROR SI HUBO FALLA AL INSERTAR EL PAQUETE DE TRANSCRIPCION
					IF @@ROWCOUNT = 0
						RAISERROR('DATABABASE_ERROR_COGNITIVE_ANALYSIS_SERVICE_PACKAGE_SAVE_FAILED', 16, 16)
				END

				-- DESBLOQUEMOS EL REGISTRO DE SALDOS DEL SERVICO USANDO LOS MISMOS PARAMETROS DE BUSQUEDA Y ACTUALIZAMOS EL SALDO DISPONIBLE
				UPDATE [dbo].[AccountVccBalance] 
					SET [IsLocked] = 1,
						[LastModifiedByUserId] = @UserApi,
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [InstallationId] = @InstallationId
						AND [AccountId] = @AccountID
						AND [VCC] = @VCC
						AND [SystemService] = @CURRENT_SYSTEM_SERVICE
						AND [AvailableBalance] >= @CURRENT_RETAINED_AMOUNT

				-- DESBLOQUEMOS EL REGISTRO DE SALDOS DEL SERVICO USANDO LOS MISMO PARAMETROS DE BUSQUEDA Y ACTUALIZAMOS EL SALDO DISPONIBLE Y CONTABLE
				UPDATE [dbo].[AccountVCCBalance] 
					SET [IsLocked] = 0, 
						[AvailableBalance] = [AvailableBalance] - @CURRENT_RETAINED_AMOUNT,
						[RetainedBalance] = [RetainedBalance] + @CURRENT_RETAINED_AMOUNT,
						[LastModifiedByUserId] = @UserApi,
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE() 
					WHERE [InstallationId] = @InstallationId 
						AND [AccountId] = @AccountId
						AND [VCC] = @VCC
						AND [SystemService] = @CURRENT_SYSTEM_SERVICE
						AND [AvailableBalance] > @CURRENT_RETAINED_AMOUNT

				IF @@ROWCOUNT = 0
					RAISERROR('DATABABASE_ERROR_INSUFFICIENT_SYSTEM_SERVICE_BALANCE', 16, 16)

			END 
			FETCH NEXT FROM MY_CURSOR INTO @CURRENT_SYSTEM_SERVICE
		END
		CLOSE MY_CURSOR
		DEALLOCATE MY_CURSOR

		-- RETORNAMOS RESULTADO 1
		SELECT 1 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

END
GO
PRINT N'Altering [dbo].[GetAccountVccRates]...';


GO
ALTER PROCEDURE [dbo].[GetAccountVccRates] (
	@InstallationId Varchar(100) = NULL, 
	@Vcc Varchar(50) = NULL,
	@ProcessId Varchar(50)  = NULL
) AS
BEGIN
	SET NOCOUNT ON

	-- DECLARAMOS UNA TABLE PARA ALMACENAR EL RESULTADO DEL SP
	DECLARE @SP_RESULT AS TABLE ([CAASPR] DECIMAL(5, 2), [CAARPM] DECIMAL(5, 2), [CABSR] DECIMAL(5, 2))
		
	-- EJECUTAMOS EL SP QUE RECUPERA EL NUMERO DE REQUEST PROMEDIO POR MINUTO Y GUARDAMOS EL RESULTADO EN LA TABLA CREADA
	INSERT @SP_RESULT EXEC [dbo].[GetCognitiveAnalysisAverageRequestPerMinute] @InstallationId, @Vcc 
	--EXEC [dbo].[GetCognitiveAnalysisAverageRequestPerMinute] @InstallationId, @Vcc 

	DECLARE @PROCESS_VALID_DURATION_TIME INT = 0
	DECLARE @PROCESS_ROUNDED_DURATION_TIME INT = 0

	DECLARE @PROCESS_CALL_PHRASES INT = 0
	DECLARE @PROCESS_TEXT_PHRASES INT = 0
	
	DECLARE @AVERAGE_COGNITIVE_ANALYSIS_SECONDS_PER_REQUEST DECIMAL(5, 2) = 0
	DECLARE @AVERAGE_COGNITIVE_ANALYSIS_REQUEST_PER_MINUTE DECIMAL(5, 2) = 0
	
	-- *TASA DE SEGURO DE FACTURACION
	DECLARE @COGNITIVE_ANALYSIS_CALL_BILLING_SECURE_RATE DECIMAL(5, 2) = 0
	DECLARE @COGNITIVE_ANALYSIS_TEXT_BILLING_SECURE_RATE DECIMAL(5, 2) = 0
	
	-- DECLARAMOS UN FLAG PARA INDICAR SI ES UN PROCESS PREVIO A LA IMPLEMENTACION DE CANALES
	DECLARE @IS_POST_CHANNEL BIT = 0

	-- EN CASO DE RECIBIR PROCESSID, BUSCAMOS EL BATCH RELACIONADO Y RECUPERAMOS SU VALIDDURATIONTIME
	IF @Processid IS NOT NULL
	BEGIN
		-- OBTENEMOS EL TOTAL DEL TIEMPO VALIDO Y DEL REDONDEADO EN MINUTOS DE CADA AUDIO
		SELECT @PROCESS_VALID_DURATION_TIME = (ASAVST.[ValidDurationTime] + ASAVST.[AlreadyTranscribedDurationTime]),
				@PROCESS_ROUNDED_DURATION_TIME = (ASAVST.[RoundedDurationTime] + ASAVST.[AlreadyTranscribedRoundedDurationTime]),
				@PROCESS_CALL_PHRASES = (ASAVST.[TotalCallPhrases] + ASAVST.[AlreadyCallPhrases]),
				@PROCESS_TEXT_PHRASES = (ASAVST.[TotalTextPhrases] + ASAVST.[AlreadyTextPhrases])
			FROM [dbo].[AccountSubAccountVCCSummaryTransaction] ASAVST (NOLOCK) 
			WHERE ASAVST.[InstallationId] = @InstallationId
				AND ASAVST.[VCC] = @Vcc
				AND ASAVST.[BatchTypeName] = 'TRANSCRIPTION'
				AND ASAVST.[BatchTypeID] = @ProcessId

		IF EXISTS (
			SELECT TOP 1 1 
				FROM [dbo].[AccountSubAccountVCCSummaryTransaction] ASAVST (NOLOCK), [dbo].[GeneralSecureRate] GSR (NOLOCK)
				WHERE ASAVST.[BatchTypeName] = 'TRANSCRIPTION'
					AND ASAVST.[CreatedDate] > GSR.[CreatedDate]
					AND ASAVST.[BatchTypeId] = @ProcessId
		)
			SET @IS_POST_CHANNEL = 1

		-- SEGUIMOS SEGUN EL PROCESS ES PREVIO O NO
		IF @IS_POST_CHANNEL = 1
		BEGIN
			-- ES UN PROCESS CREADO CUANDO SE USAN INTERACCIONES TIPO CALL Y TEXT
			SELECT TOP 1 @COGNITIVE_ANALYSIS_CALL_BILLING_SECURE_RATE = GSR.[SpeechCognitiveAnalysisSecureRate],
							@COGNITIVE_ANALYSIS_TEXT_BILLING_SECURE_RATE = GSR.[SpeechCognitiveAnalysisSecureRate]
				FROM [dbo].[GeneralSecureRate] GSR (NOLOCK)

			-- DESPUES DE LA IMPLEMENTACION DE CANALES REGISTRAMOS EN LAS TABLAS DE SPEECH Y BILLING LAS FRASES POR AUDIO EN LA TABLA DETAILED, ESTO DE DEBE LLEVAR A LA TABLA SUMMARY
		END
		ELSE
		BEGIN
			-- ES UN PROCESS CREADO CUANDO SOLO USABAN INTERACCIONES TIPO CALL, POR ESO SOLO NECESITA MARGEN PARA CALL 
			SELECT TOP 1 @COGNITIVE_ANALYSIS_CALL_BILLING_SECURE_RATE = GSR.[QualityCallCognitiveAnalysisSecureRate]
				FROM [dbo].[GeneralSecureRate] GSR (NOLOCK)
			
			-- ANTES DE LA IMPLEMENTACION DE CANALES NO SE REGISTRABAN LA CANTIDAD DE FRASES POR AUDIO EN TABLA DETAILED
		END
	END 
	ELSE 
	BEGIN
		-- PLAN DE EVALUACION USA LAS TASAS DE ANALISIS COGNITIVO
		SELECT TOP 1 @COGNITIVE_ANALYSIS_CALL_BILLING_SECURE_RATE = GSR.[QualityCallCognitiveAnalysisSecureRate],
						@COGNITIVE_ANALYSIS_TEXT_BILLING_SECURE_RATE = GSR.[QualityTextCognitiveAnalysisSecureRate]
			FROM [dbo].[GeneralSecureRate] GSR (NOLOCK)
	END

	-- RECUPERAMOS LOS DATOS DE REQUEST PROMEDIO Y TASA DE SEGURIDAD RECUPERADAS EN EL SP
	SELECT TOP 1 @AVERAGE_COGNITIVE_ANALYSIS_SECONDS_PER_REQUEST = SPR.[CAASPR],
			@AVERAGE_COGNITIVE_ANALYSIS_REQUEST_PER_MINUTE = SPR.[CAARPM]
			--@COGNITIVE_ANALYSIS_CALL_BILLING_SECURE_RATE = SPR.[CABSR] -- DEJARA DE USARSE PORQUE AHORA SE TOMA DE LA BD
		FROM @SP_RESULT SPR 

	-- HACEMOS LA CONSULTA A LA BASE DE DATOS
	SELECT AV.[TranscriptionRatePerHour]							'transcriptionRatePerHour',
		AV.[TranscriptionRatePerSecond]								'transcriptionRatePerSecond',
		AV.[SemanticAnalysisRatePerTransaction]						'semanticAnalysisRatePerTransaction',
		AV.[CognitiveAnalysisRatePerTransaction]					'cognitiveAnalysisRatePerTransaction',
		--(SELECT [CAARPM] FROM @SP_RESULT)							'cognitiveAnalysisAverageRequestPerMinute'
		@PROCESS_VALID_DURATION_TIME								'processTotalValidDurationTime',
		@PROCESS_ROUNDED_DURATION_TIME								'processRoundedValidDurationTime', 
		@AVERAGE_COGNITIVE_ANALYSIS_SECONDS_PER_REQUEST				'cognitiveAnalysisAverageSecondsPerRequest',
		@AVERAGE_COGNITIVE_ANALYSIS_REQUEST_PER_MINUTE				'cognitiveAnalysisAverageRequestPerMinute',
		@COGNITIVE_ANALYSIS_CALL_BILLING_SECURE_RATE				'cognitiveAnalysisBillingSecureRate',
		@COGNITIVE_ANALYSIS_TEXT_BILLING_SECURE_RATE				'cognitiveAnalysisTextBillingSecureRate',
		@PROCESS_CALL_PHRASES										'processCallPhrases',
		@PROCESS_TEXT_PHRASES										'processTextPhrases',
		@IS_POST_CHANNEL											'isProcessPostChannel'
	FROM dbo.[AccountVCC] AV (NOLOCK)
	WHERE AV.[InstallationId] = @InstallationId
		AND AV.[VCC] = @Vcc
	
	SET NOCOUNT OFF
END
GO
PRINT N'Update complete.';


GO
