PRINT N'Modificando [dbo].[GetPlatformAccounts]...';


GO
ALTER PROCEDURE [dbo].[GetPlatformAccounts] (
	@InstallationId Varchar(50) = NULL
	)
AS
BEGIN
	-- ESTE SERVICIO RETORNA TODAS LAS CUENTAS Y SUBCUENTAS ASOCIADAS A UNA PLATAFORMA

	SET NOCOUNT ON

	-- DECLARAMOS UNA VARIABLE PARA ALCENAR EL ESTADO DE LA CUENTA 
	DECLARE @ACCOUNT_STATUS BIT

	SET @ACCOUNT_STATUS = 0

	-- SETTEAMOS EL ESTADO DE LA PLATAFORMA SEGUN SU CAMPO ISACTIVATED
	SELECT @ACCOUNT_STATUS = P.[IsActivated]
		FROM [dbo].[Platform] P (NOLOCK)
		WHERE P.[InstallationId] = @InstallationId

	-- SI LA PLATAFORMA ESTA ACTIVA, HACEMOS LA BUSQUEDA DE CUENTAS
	IF (@ACCOUNT_STATUS = 1) 
	BEGIN
		SELECT A.[InstallationId]				'installationId',
				A.[ID]							'id',
				PD.[ClientName]					'clientName',
				A.[AccountId]					'accountId', 
				A.[SubAccountId]				'subAccountId',
				A.[User]						'user',
				A.[Token]						'token',
				COUNT(AV.[VCC])					'vccs'
			FROM dbo.[Account] A (NOLOCK) 
			LEFT JOIN dbo.[PlatformData] PD (NOLOCK)
				ON PD.[PlatformHash] = A.[PlatformHash]
					AND PD.[InstallationId] = A.[InstallationId]
			LEFT JOIN dbo.[AccountVCC] AV (NOLOCK)
				ON AV.[InstallationId] = A.[InstallationId]
					AND AV.[AccountId] = A.[AccountId]
					AND (
						(AV.[SubAccountId] IS NULL AND A.[SubAccountId] IS NULL)
						OR 
						(AV.[SubAccountId] = A.[SubAccountId])
					)
			WHERE A.[InstallationId] = @InstallationId
				AND A.[Enabled] = 1
			GROUP BY A.[InstallationId], A.[ID], PD.[ClientName], A.[AccountId], A.[SubAccountId],
				A.[User], A.[Token] 
	END
	-- SI LA PLATAFORMA NO ESTA ACTIVA, RETORNAMOS UN RESULT 0
	ELSE 
	BEGIN 
		SELECT 0 'result'
	END
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetRelatedSubAccounts]...';


GO
ALTER PROCEDURE [dbo].[GetRelatedSubAccounts] (
	@InstallationId Varchar(100) = NULL
	--@UserId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	-- DECLARAMOS UNA VARIABLE PARA ALCENAR EL NIVEL DE LA CUENTA 
	DECLARE @ACCOUNT_LEVEL INT

	SET @ACCOUNT_LEVEL = 1

	/*
	-- RECUPERAMOS EL NIVEL DE LA CUENTA
	SELECT @ACCOUNT_LEVEL = A.[AccountLevel]
		FROM Account A (NOLOCK)
	WHERE A.[AccountId] = @AccountId
		AND [Enabled] = 1
	*/
	
	-- SI EL NIVEL DE LA CUENTA ES 1, SE REFIERE AL DUENO DE LA PLATAFORMA
	IF (@ACCOUNT_LEVEL = 1)
	BEGIN 

		-- BUSCAMOS TODAS LAS SUBCUENTAS ENABLED 1 GUARDADAS
		SELECT A.[InstallationId]				'installationId',
				A.[AccountId]					'accountId',
				A.[SubAccountId]				'subAccountId',
				A.[User]						'user',
				A.[Token]						'token',
				COUNT(AV.[VCC])					'vccs'
		FROM Account A (NOLOCK)
		LEFT JOIN dbo.[AccountVCC] AV (NOLOCK)
			ON AV.[InstallationId] = A.[InstallationId]
				AND AV.[AccountId] = A.[AccountId]
				AND (
					(AV.[SubAccountId] IS NULL AND A.[SubAccountId] IS NULL)
					OR 
					(AV.[SubAccountId] = A.[SubAccountId])
				)
		WHERE A.[InstallationId] = @InstallationId
			AND A.[SubAccountId] IS NOT NULL 
			AND A.[Enabled] = 1
		GROUP BY A.[InstallationId], A.[AccountId], A.[SubAccountId], A.[User], A.[Token] 
		ORDER BY A.[AccountId] ASC

	END
	ELSE
	BEGIN 
		
		-- BUSCAMOS TODAS LAS SUBCUENTAS RELACIONADAS A LA CUENTA 
		SELECT A.[InstallationId]				'installationId',
				A.[AccountId]					'accountId',
				A.[SubAccountId]				'subAccountId',
				A.[User]						'user',
				A.[Token]						'token',
				COUNT(AV.[VCC])					'vccs'
		FROM Account A (NOLOCK)
		LEFT JOIN dbo.[AccountVCC] AV (NOLOCK)
			ON AV.[InstallationId] = A.[InstallationId]
				AND AV.[AccountId] = A.[AccountId]
				AND (
					(AV.[SubAccountId] IS NULL AND A.[SubAccountId] IS NULL)
					OR 
					(AV.[SubAccountId] = A.[SubAccountId])
				)
		WHERE A.[InstallationId] = @InstallationId
			AND A.[Enabled] = 1
			--AND A.[AccountOwner] = @AccountId 
		GROUP BY A.[InstallationId], A.[ID], A.[AccountId], A.[SubAccountId], A.[User], A.[Token] 
		ORDER BY A.[AccountId] ASC

	END
	
	SET NOCOUNT OFF
END
GO
PRINT N'Actualización completada.';


GO
